package com.adaapa.adaojek.servlets;

import com.adaapa.adaojek.middlewares.CookieCheck;
import com.adaapa.adaojek.services.ServiceConnector;
import com.adaapa.adaojek.stub.ApplicationCookie;
import com.adaapa.bean.UserBean;
import com.adaapa.bean.WebServiceBean;
import com.adaapa.ojekservice.OjekOnline;
import com.google.gson.Gson;
import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class OrderServlet extends HttpServlet {
  Gson gson = new Gson();

  @Override
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
      throws ServletException, IOException {
    if (!CookieCheck.redirectIfTokenNotFound(req, resp, "login")) {
      ApplicationCookie cookie = CookieCheck.getCookie(req);

      req.setAttribute("user", cookie.getUsername());

      OjekOnline service = ServiceConnector.getServiceClass();
      WebServiceBean webServiceBean = gson.fromJson(service.getProfile(cookie.getToken()),
              WebServiceBean.class);

      if (webServiceBean.getStatus().equals(WebServiceBean.STATUS_INVALID)) {
        resp.sendRedirect("logout");
      } else {
        UserBean ubean = gson.fromJson(webServiceBean.getBody(), UserBean.class);

        if (ubean.getIsDriver()) {
          req.getRequestDispatcher("WEB-INF/order_driver.jsp").forward(req, resp);
        } else {
          req.getRequestDispatcher("WEB-INF/order.jsp").forward(req, resp);
        }
      }
    }
  }
}
