<%@ include file="/component/header.html" %>
<%@ include file="/component/nav.html" %>

<div class="container" ng-app="chatApp">
    <div class="wrapper row">
        <div>
            <div class="page-title row txt-center height-fit float-container">
                <div class="float-left">
                    <h1 class="inline-block">MAKE AN ORDER</h1>
                </div>
            </div>
        </div>

        <div class="order-menu">
            <ul class="order-ul">
                <li class="order-item">
                    <div class="order-number">1</div>
                    <div class="order-number-desc">Select Destination</div>
                </li>
                <li class="order-item">
                    <div class="order-number">2</div>
                    <div class="order-number-desc">Select a Driver</div>
                </li>
                <li class="order-item active">
                    <div class="order-number">3</div>
                    <div class="order-number-desc">Chat Driver</div>
                </li>
                <li class="order-item">
                    <div class="order-number">4</div>
                    <div class="order-number-desc">Complete your order</div>
                </li>
            </ul>
        </div>

        <div ng-controller="ChatController as chatController">
            <div id="scrollArea">
                <div ng-repeat="chat in chatList">
                    <p class="chat-bubble-left" ng-if="chat.from === 'them'">{{chat.text}}</p>
                    <p class="chat-bubble-right" ng-if="chat.from === 'me'">{{chat.text}}</p>
                </div>
            </div>
            <div class="chat-box">
                <form class="form-chat-box" ng-submit="addChat()">
                    <input class="text-input" ng-model="chatText"
                           placeholder="Enter a message">
                    <input class="send-button" type="submit" value="Kirim">
                </form>
            </div>
        </div>

        <div class="close-box">
            <form action="complete_order" class="chat-input" method="get">
                <input type="hidden" name="pickUp" value="${pickup}">
                <input type="hidden" name="destination" value="${destination}">
                <input type="hidden" name="driverId" value="${driverProfile.getUsername()}">
                <input type="submit" class="close-button" value="CLOSE">
            </form>
        </div>
    </div>
</div>

<%@ include file="/component/footer.html" %>

<script src="js/converse.js"></script>
<script src="https://www.gstatic.com/firebasejs/4.6.2/firebase.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.6.6/angular.min.js"></script>
<script>
    window.onload = toggleActive("nav-order");
</script>
<script>
    angular.module('chatApp', [])
        .service('ConverseService', converse)
        .controller('ChatController', function ($scope, $timeout, ConverseService) {
            let account = new ConverseService.User(1)

            $scope.chatList = []

            // Initialize Firebase.
            account.initAsync()
                .then(function (chats) {
                    console.log('Chat service is initialized.')

                    $timeout(function () {
                        $scope.chatList = chats
                    }, 0)
                })
                .catch(function (e) {
                    console.log(e)
                })

            account.onchat = function (msg) {
                $timeout(function () {
                    $scope.chatList.push({
                        from: 'them',
                        text: msg
                    })
                }, 0)
            }

            $scope.addChat = function () {
                if ($scope.chatText.length !== 0) {
                    let message = $scope.chatText

                    account.chatAsync(message)
                        .then(function () {
                            $timeout(function () {
                                $scope.chatList.push({
                                    from: 'me',
                                    text: message
                                })
                            }, 0)
                        })
                        .catch(function (e) {
                            console.log(e)
                        })
                }

                $scope.chatText = ''
            }
        })
</script>
