/*
 * Tugas Besar 3 WBD - AMEN
 */

'use strict'

const express = require('express')

const chat = require('./chat')
const hub = require('../service/hub')
const relay = require('../service/relay')

let app = express.Router()

// Mount chat controller.
app.use('/chat', chat)

// Administrations.

app.post('/wait', async function (req, res, next) {
  let id = req.projek.driver.id

  try {
    let userId = await hub.waitAsync(id, function (reject) {
      req.connection.on('close', () => reject(new Error('Aborted')))
    })

    res.json({
      'user_id': userId
    })
  } catch (e) {
    next(e)
  }
})

app.post('/pick', function (req, res) {
  let id = req.projek.driver.id
  let userId = req.body.user_id

  // Pick driver by user.
  hub.pick(id, userId)

  // Associate user with driver.
  relay.associate(userId, id)

  res.json({})
})

// Queries.

app.get('/', function (req, res) {
  let id = req.projek.driver.id

  // Check if driver exists.
  hub.check(id)

  res.json({})
})

module.exports = app
