/*
 * Tugas Besar 3 WBD - AMEN
 */

'use strict'

const cors = require('cors')
const express = require('express')
const bodyParser = require('body-parser')

const driver = require('./driver')

let app = express.Router()

app.use(cors())
app.use(bodyParser.json())

// API endpoints.

let projekMiddleware = function (req, res, next) {
  req.projek = {
    driver: {
      id: req.params.id
    }
  }
  next()
}

app.use('/driver/:id', projekMiddleware, driver)

// Handle errors.

app.use(function (err, req, res, next) {
  console.log(err)

  res.status(500).json({
    error: err.message
  })
})

module.exports = app
