/*
 * Tugas Besar 3 WBD - AMEN
 */

'use strict'

const mongoose = require('mongoose')

// Connect database.
mongoose.connect(process.env.MONGODB_URI)

let ChatHistorySchema = mongoose.Schema({
  participant_ids: [Number],
  chats: [{
    owner_id: Number,
    content: String
  }]
})

let ChatHistory

ChatHistorySchema.statics.prepareAsync = async function (participantIds) {
  participantIds.sort()

  let result = await this.findOne({ participant_ids: participantIds })

  if (!result) {
    result = new ChatHistory({
      participant_ids: participantIds,
      chats: []
    })
  }

  return result
}

ChatHistory = mongoose.model('ChatHistory', ChatHistorySchema)

module.exports = {
  ChatHistory: ChatHistory
}
