/*
 * Tugas Besar 3 WBD - AMEN
 */

'use strict'

let drivers = {}

module.exports = {
  async waitAsync (id, rejectFunc) {
    let promise = new Promise((resolve, reject) => {
      drivers[id] = {
        resolve: resolve,
        reject: reject
      }

      // Pass reject function.
      if (rejectFunc) {
        rejectFunc(reject)
      }
    })

    try {
      return await promise
    } finally {
      delete drivers[id]
    }
  },

  check (id) {
    let handle = drivers[id]

    if (!handle) {
      throw new Error(`Driver ID ${id} is not connected`)
    }
  },

  pick (id, userId) {
    let handle = drivers[id]

    if (!handle) {
      throw new Error(`Driver ID ${id} is not connected`)
    }

    handle.resolve(userId)
  },

  reject (id, reason) {
    let handle = drivers[id]

    if (!handle) {
      throw new Error(`Driver ID ${id} is not connected`)
    }

    handle.reject(reason)
  }
}
